package com.blue.penecu;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

public class Fileman  implements  AdapterView.OnItemClickListener,Handler.Callback, View.OnClickListener, ActresDispatcher {
    //-------------------------------------- プロパティ定義
    public static final int IDA_FUPLOAD = 3;
    public static final int IDA_FDOWNLOAD =4;
    public static final int IDA_PGMUPDATE=5;
    private MainActivity m_parent;
    private ArrayAdapter<String> m_adaptarret;
    private ListView m_lvret;
    private String m_sselfname;

    //-------------------------------------- メソッド
    public Fileman(MainActivity parent) {
        m_parent = parent;
        m_parent.m_Disps.add(this);     // ActivityResultの為に

        String[]    strfnames  = {  //"pgmfile",
                "mapfile1", "mapfile2",  "log1", "log2", "diaginfo"};

        ListView lv = (ListView) m_parent.findViewById(R.id.lvfiles);
        m_lvret = (ListView) m_parent.findViewById(R.id.lvinfos);
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(parent,
                android.R.layout.  simple_list_item_single_choice     , strfnames);
        m_adaptarret = new ArrayAdapter<String>(parent, R.layout.simple1line );
        lv.setAdapter(adapter);
        lv.setOnItemClickListener(this);

        m_lvret.setAdapter(m_adaptarret);

        Button btn = (Button)parent.findViewById(R.id.btnFupload);
        btn.setOnClickListener(this);
        btn = (Button) parent.findViewById(R.id.btnFdownload);
        btn.setOnClickListener(this);
        btn = (Button) parent.findViewById(R.id.btnFupdate);
        btn.setOnClickListener(this);
    }

    //-------------------------------------- ボタンクリック
    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
        ListView listView = (ListView) parent;
        m_sselfname = (String) listView.getItemAtPosition(position);
    }
        //-------------------------------------- ボタンクリック
    public void onClick(View v) {
        Button btn = (Button)v;

        if(btn.getId() != R.id.btnFupdate) {
            if (m_sselfname == null || m_sselfname.isEmpty()) {
                MainActivity.ShowMessage("ファイルが選択されていません");
                return;
            }
        }

        Intent ItGetFile = new Intent(m_parent, OpenFileActivity.class);
        // 有効化されて戻ったらENABLEパラメータ発行
        int  aid;
        switch(btn.getId()) {
            case R.id.btnFupdate:
                aid = IDA_PGMUPDATE;
                break;
            case R.id.btnFupload:
                aid = IDA_FUPLOAD;
                break;
            case R.id.btnFdownload:
                aid = IDA_FDOWNLOAD;
                break;
            default:
                aid = 0;
        }

        m_parent.startActivityForResult(ItGetFile, aid);
    }

    @Override
    public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
        switch(requestCode) {
            case IDA_PGMUPDATE:
                if (resultCode == Activity.RESULT_OK) {  // 正常に取得できたら
                    String sfname = data.getExtras().getString(OpenFileActivity.FILENAME);
                    m_parent.getM_comtask().updatePGM(sfname, new Handler(this));
                }
                break;
            case IDA_FUPLOAD:
                if (resultCode == Activity.RESULT_OK) {  // 正常に取得できたら
                    String sfname = data.getExtras().getString(OpenFileActivity.FILENAME);
                    m_parent.getM_comtask().sendFile(m_sselfname, sfname, new Handler(this));
                }
                break;
            case IDA_FDOWNLOAD:
                if (resultCode == Activity.RESULT_OK) {  // 正常に取得できたら
                    String sfname = data.getExtras().getString(OpenFileActivity.FILENAME);
                    m_parent.getM_comtask().recvFile(m_sselfname, sfname,  new Handler(this));
                }
                break;
        }
        return false;
    }

    public boolean handleMessage(Message msg) {
        switch (msg.what) {
            case commtasks.MESSAGE_UPDATEREJECTED:      {
                m_adaptarret.add("現在更新できません");
            }
            break;
            case commtasks.MESSAGE_UPDATEFINISH:    {
                m_adaptarret.add("更新終了しました");
                TextView tv = (TextView)m_parent.findViewById(R.id.txtCure);
                tv.setText("");
            }
            break;
            case commtasks.MESSAGE_UPDATEDATAERROR:    {
                m_adaptarret.add("データエラーが発生しました");
            }
            break;
            case commtasks.MESSAGE_UPDATEFINISHERROR:    {
                m_adaptarret.add("更新に失敗発生しました");
            }
            break;
            case commtasks.MESSAGE_UPDATEGOES: {
                TextView tv = (TextView)m_parent.findViewById(R.id.txtCure);
                String sNow = "更新中" + msg.arg1 ;
                tv.setText(sNow);
            }
                break;
            case commtasks.MESSAGE_COMM_ERROR: {
                String strmsg = "通信エラーが発生しました";
                if ( msg.obj != null)
                    strmsg += " " + (String)msg.obj ;
                m_adaptarret.add(strmsg);
            }
            break;
            case commtasks.MESSAGE_DOWN_REJECT:
                m_adaptarret.add("現在取得できません");
                break;
            case commtasks.MESSAGE_DOWN_ERROR:
                m_adaptarret.add("指定したファイルは取得できません");
                break;
            case commtasks.MESSAGE_DOWN_FINISH:
                m_adaptarret.add("データを取得しました");
                break;
            case commtasks.MESSAGE_FILE_ERROR:
                m_adaptarret.add((String)msg.obj);
                break;

        }
        int itemCount = m_lvret.getCount();
        m_lvret.setSelection(itemCount - 1);

        return true;
    }
}