package com.blue.penecu;

import android.app.Activity;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.os.Environment;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

import java.io.File;
import java.util.Set;

//-------------------- ダウンロードフォルダの中のファイルの列挙と選択 -------------------- /
public class OpenFileActivity extends Activity implements
        AdapterView.OnItemClickListener {

    //-------------------------------------------- 定数定義
    private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
    private final static int MP = LinearLayout.LayoutParams.MATCH_PARENT;
    public static String FILENAME = "filename";
    private ArrayAdapter<String> FileList;
    private String strSDPath;
    private int m_selresult;        //内部クラスからの結果設定用

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // ダイアログタイトルなし
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        // 戻り値の初期化
        setResult(Activity.RESULT_CANCELED);
        // ダイアログレイアウトの作成
        LinearLayout layout = new LinearLayout(this);
        layout.setOrientation(LinearLayout.VERTICAL);
        setContentView(layout);

        // デバイス配列
        FileList = new ArrayAdapter<String>(this,R.layout.rowdata);

        // リストビュー生成
        ListView listView = new ListView(this);
        listView.setLayoutParams(new LinearLayout.LayoutParams(MP, WC));
        listView.setAdapter(FileList);
        layout.addView(listView);
        listView.setOnItemClickListener(this);
        strSDPath = Environment.getExternalStorageDirectory().getPath() + "/download";
        File[] files = new File(strSDPath).listFiles();
        for(int i = 0; i < files.length; i++) {
            if(files[i].isFile())
                FileList.add(files[i].getName());
        }
        FileList.add("+ 新規ファイル");
    }


    @Override
    protected void onDestroy() {
        super.onDestroy();
    }


    //----------------------------------------  新規ファイル名が設定された場合こちら
    protected void NewFile(String sname) {
        Intent intent = new Intent();
        intent.putExtra(FILENAME, strSDPath + "/" +sname);
        setResult(Activity.RESULT_OK, intent);
        finish();
    }

    //----------------------------------------  ファイル名の選択リストクリック処理
    public void onItemClick(AdapterView<?> av, View v, int arg2, long arg3) {

        String  selFile = ((TextView) v).getText().toString();

        if(selFile == "↑")   {

        }
        else if(selFile == "+ 新規ファイル") {
            //テキスト入力を受け付けるビューを作成します。
            final EditText editView = new EditText(this);
            new AlertDialog.Builder(this)
                    .setIcon(android.R.drawable.ic_dialog_info)
                    .setTitle(getString(R.string.ids_inputfname))
                            //setViewにてビューを設定します。
                    .setView(editView)
                    .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            String sInput = editView.getText().toString();
                            if(!sInput.isEmpty())
                                NewFile(sInput);
                        }
                    })
                    .setNegativeButton(getString(R.string.ids_cancel), new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int whichButton) {
                            m_selresult = 2;
                        }
                    })
                    .show();
        }
        else {

            // 端末のアドレスを戻り値として設定
            String info = strSDPath + "/" + selFile;
            Intent intent = new Intent();
            intent.putExtra(FILENAME, info);
            setResult(Activity.RESULT_OK, intent);
            finish();
        }
    }
}
