package com.blue.penecu;

import android.app.Activity;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.TabHost;
import android.widget.ToggleButton;

import java.util.ArrayList;
import java.util.List;


public class Oscillo extends View implements Handler.Callback, CompoundButton.OnCheckedChangeListener {
    public final int ADSAMPLING_COUNTS = 500;
    public final int AD_TARGETS = 8;
    public final int ADRESULT_AMOUNT = ADSAMPLING_COUNTS * AD_TARGETS;
    private static int TrigLevel, Index, temp;
    private static byte Hsync, FirstFlag, CHFlag;
    private int i, j;
    private short[] DataBuffer = new short[ADRESULT_AMOUNT];
    private int  m_ngraph = 1;
    private boolean  m_goon = false;
    ArrayList<ToggleButton> m_listBtns = new ArrayList<ToggleButton>() ;
    MainActivity m_parent;
    TabHost m_parentTab;
    ToggleButton    m_tbGoOn;           // データ連続取得するかどうかのチェック用
    ToggleButton    m_tb2graph;         // 2グラフかどうか

    public Oscillo(Context context){
        super(context);
        m_parent = (MainActivity)context;
        m_parentTab = (TabHost)m_parent.findViewById(R.id.idtabHost);

        ToggleButton tb;
        m_tbGoOn = (ToggleButton) m_parent.findViewById(R.id.chkOsGoOn);
        m_tbGoOn.setOnCheckedChangeListener(this);
        m_tb2graph = (ToggleButton) m_parent.findViewById(R.id.chkOs2disp);
        m_tb2graph.setOnCheckedChangeListener(this);
        tb = (ToggleButton) m_parent.findViewById(R.id.btnOs1);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
        tb = (ToggleButton) m_parent.findViewById(R.id.btnOs2);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
        tb = (ToggleButton)m_parent. findViewById(R.id.btnOs3);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
        tb = (ToggleButton)m_parent. findViewById(R.id.btnOs4);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
        tb = (ToggleButton) m_parent.findViewById(R.id.btnOs5);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
        tb = (ToggleButton)m_parent. findViewById(R.id.btnOs6);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
        tb = (ToggleButton) m_parent.findViewById(R.id.btnOs7);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
        tb = (ToggleButton)m_parent. findViewById(R.id.btnOs8);
        tb.setOnCheckedChangeListener(this);
        m_listBtns.add(tb);
    }

    //---------------------------------// AD結果データ取得、タブが選択されているときのみ
    public void getADResults() {
        if (m_parentTab.getCurrentTab() == 1) {
            m_parent.getM_comtask().getADResult(new Handler(this));
        }
    }

    //---------------------------------// イベントハンドラ、通信スレッドからの戻り値に使用
    public boolean handleMessage(Message msg) {
        if(msg.what == commtasks.MESSAGE_ADRESULT) {
            byte[] bret = (byte[])msg.obj;  // unsigned byte データをshort に補正する
            if (bret != null) {
                for(int i = 0; i < ADRESULT_AMOUNT; i++) {
                    if(i < bret.length)
                        DataBuffer[i] = (short)(bret[i] & 0xff);
                    else
                        DataBuffer[i] = 0;
                }
            }
            invalidate();
            if (m_goon) {
                try { Thread.sleep(100);}     catch(Exception e) {
                }
                getADResults();
            }
        }
        return true;
    }

    //---------------------------------// イベントハンドラ、通信スレッドからの戻り値に使用
    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
        if(m_tbGoOn == buttonView) {
            m_goon = isChecked;
            if(isChecked)
                getADResults();
        }
        else if(m_tb2graph == buttonView) {
            m_ngraph =  isChecked ? 2 : 1;
        }
        else {      // 最大4ボタン程度同時押下にするための処理
            if (isChecked) {
                int cntChk = isChecked ? 1 : 0, nShouldOff;
                for (int i = 0; i < m_listBtns.size(); i++) {
                    CompoundButton btn = m_listBtns.get(i);
                    if (btn == buttonView) {

                    } else {
                        if (btn.isChecked())
                            cntChk++;
                    }
                }
                nShouldOff = cntChk - 4;
                for (int i = 0; i < m_listBtns.size() && nShouldOff > 0; i++) {
                    CompoundButton btn = m_listBtns.get(i);
                    if (btn != buttonView && btn.isChecked()) {
                        nShouldOff--;
                        m_listBtns.get(i).setChecked(false);
                    }
                }
            }
        }
        invalidate();
    }

    //--------------------------------// 描画固有の定数など
    static final int m_margine = 50;
    //--------------------------------// グラフ描画実行メソッド
    public void onDraw(Canvas canvas)	{
        super.onDraw(canvas);
        int  cx = getWidth(), cy = getHeight();
        int  xrange = cx - m_margine * 2, yrange = (cy - (m_margine * 2) * 2 ) / 2;
        Paint set_paint = new Paint();	 		//背景色の設定
        canvas.drawColor(Color.BLACK);
        int nxLines = ADSAMPLING_COUNTS / 10;   // 10単位程度で目盛りを描画
        int  pitch10x = xrange / nxLines, pichy = yrange / 5;
        int  ofx = m_margine;
        for(int n = 0; n < m_ngraph; n++) {
            set_paint.setColor(Color.BLUE);			// 座標の表示 青色で表示
            set_paint.setStrokeWidth(1);
            int  ofy = cy / 2 * n + m_margine;
            // n本あるので、10本単位でn+1本 線をひく
            for (i = 0; i <= nxLines; i++)                    // 縦軸の表示　
                canvas.drawLine(i * pitch10x + ofx, ofy,  i * pitch10x + ofx, ofy + yrange, set_paint);
            for (i = 0; i < 5; i++)                        // 横軸の表示　7本　中央を0とする
                canvas.drawLine(ofx, i * pichy + ofy, xrange + ofx, i * pichy + ofy, set_paint);
            // X軸とY軸の0ライン白色で描画
            set_paint.setColor(Color.WHITE);
            canvas.drawLine(ofx, 4 * pichy + ofy, ofx + xrange, 4 * pichy + ofy, set_paint);
            set_paint.setStrokeWidth(2);
            canvas.drawLine(ofx , ofy, ofx , ofy + yrange, set_paint);
            canvas.drawLine(ofx, 0 * pichy + ofy, ofx + xrange, 0 * pichy + ofy, set_paint);
            canvas.drawLine(ofx + xrange , ofy, ofx + xrange , ofy + yrange, set_paint);
            canvas.drawLine(ofx, 5 * pichy + ofy, ofx + xrange, 5 * pichy + ofy, set_paint);
            // 軸目盛の表示
            set_paint.setAntiAlias(true);
            set_paint.setTextSize(20f);
            set_paint.setColor(Color.WHITE);
            for (i = 1; i <= nxLines / 2; i++)                    // X座標目盛
                canvas.drawText(Integer.toString(i * 20), 30 + i * pitch10x * 2, 5 * pichy + ofy + 30, set_paint);
            for (i = 0; i <= 5; i++)                    // Y座標目盛
                canvas.drawText(Integer.toString(4 - i), 28, ofy + i * pichy, set_paint);

        }

        double xunit = (double)xrange / ADSAMPLING_COUNTS;
        double yunit = 0.0 - (double)pichy * 3 / 255;         // Y 3目盛りぐらいで最大になるように255段階にする

        set_paint.setStrokeWidth(5);
        for(int i = 0, j = 0; i < 8; i++) {
            ToggleButton tb = m_listBtns.get(i);
            if(!tb.isChecked())
                continue;
            set_paint.setColor(tb.getCurrentTextColor());
            boolean  is1graph  = m_ngraph == 1 || (j & 1) == 0;
            int  ofy =  (is1graph ? 0 :  cy / 2) + m_margine + pichy * 4;    // 0 地点
            for(int k = 0; k < ADSAMPLING_COUNTS - 1; k++) {
                int  x1 = ofx + (int)(xunit * k);
                int  y1 = (int)(yunit * DataBuffer[k * AD_TARGETS + i] + ofy);
                int  x2 = ofx + (int)(xunit * (k + 1));
                int  y2 = (int)(yunit * DataBuffer[(k + 1) * AD_TARGETS + i] + ofy);
                canvas.drawLine(x1, y1, x2, y2, set_paint);
            }
            j++;
        }
    }

    public void doTest() {
        int[]  ibase = new int[8];

        for(int i = 0; i < 8; i++)
            ibase[i] = (int)(Math.random() * 255);
        for(int i = 0; i < ADSAMPLING_COUNTS; i++) {
            for(int j = 0; j < 8; j++) {
                ibase[j] += (4 - (int) (Math.random() * 9));
                if(ibase[j] < 0)    ibase[j] = 0;
                if(ibase[j] > 255)  ibase[j] = 255;
                DataBuffer[i * 8 + j] = (short)ibase[j];
            }
        }
        invalidate();
    }

    public static int convertDpToPx(Context context, int dp){
        float d = context.getResources().getDisplayMetrics().density;
        return (int)((dp * d) + 0.5);
    }
}
