package com.blue.penecu;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.TextView;
import android.widget.Toast;


public class Setting1A extends Activity implements View.OnClickListener, Handler.Callback  {

    protected commtasks.Setting1Data  m_data = new commtasks.Setting1Data();

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.setting1);
        Button btnSave = (Button) findViewById(R.id.btns1save);
        btnSave.setOnClickListener(this);

        commtasks.recvSetting1(m_data);

        TextView txt = (TextView) findViewById(R.id.txts1accptime);
        txt.setText(String.valueOf(m_data.nAccelPumpSpan / 10.0).toString());
        txt = (TextView) findViewById(R.id.txts1curtbl);
        txt.setText(String.valueOf(m_data.ncurrent).toString());
        txt = (TextView) findViewById(R.id.txts1defbtdc);
        txt.setText(String.valueOf(m_data.defBTDCFireVal / 10.0).toString());
        txt = (TextView) findViewById(R.id.txts1defignt);
        txt.setText(String.valueOf(m_data.defIgnSpan / 100.0).toString());
        txt = (TextView) findViewById(R.id.txts1definjt);
        txt.setText(String.valueOf(m_data.defInjSpan / 100.0).toString());
        txt = (TextView) findViewById(R.id.txts1maxaccl);
        txt.setText(String.valueOf(m_data.naccelmax).toString());
        txt = (TextView) findViewById(R.id.txts1minaccl);
        txt.setText(String.valueOf(m_data.naccelmin / 100.0).toString());
        CheckBox chk = (CheckBox) findViewById(R.id.chks1normalmode);
        chk.setChecked(m_data.IsTunnelMode != 0);
        chk = (CheckBox) findViewById(R.id.chks1accpon);
        chk.setChecked(m_data.IsUseAccelPump != 0);

        Button btnGetmin = (Button)findViewById(R.id.btns1getmin);
        Button btnGetmax = (Button)findViewById(R.id.btns1getmax);
        btnGetmin.setOnClickListener(this);
        btnGetmax.setOnClickListener(this);
    }

    protected void OnSave() {
        double dval;
        int ival;

        try {
            TextView txt = (TextView) findViewById(R.id.txts1accptime);
            dval = Double.parseDouble(txt.getText().toString());
            m_data.nAccelPumpSpan =  (int)(dval * 10);
            txt = (TextView) findViewById(R.id.txts1curtbl);
            ival = Integer.parseInt(txt.getText().toString());
            m_data.ncurrent = ival == 1 ? 1 : 0;
            txt = (TextView) findViewById(R.id.txts1defbtdc);
            dval = Double.parseDouble(txt.getText().toString());
            m_data.defBTDCFireVal = (int)(dval * 10);
            txt = (TextView) findViewById(R.id.txts1defignt);
            dval = Double.parseDouble(txt.getText().toString());
            m_data.defIgnSpan = (int)(dval * 100);
            txt = (TextView) findViewById(R.id.txts1definjt);
            dval = Double.parseDouble(txt.getText().toString());
            m_data.defInjSpan = (int)(dval * 100);
            CheckBox chk  = (CheckBox) findViewById(R.id.chks1normalmode);
            m_data.IsTunnelMode = chk.isChecked() ? 1 : 0;
            chk = (CheckBox) findViewById(R.id.chks1accpon);
            m_data.IsUseAccelPump  = chk.isChecked() ? 1 : 0;
            txt = (TextView) findViewById(R.id.txts1minaccl);
            m_data.naccelmin = Integer.parseInt(txt.getText().toString());
            txt = (TextView) findViewById(R.id.txts1maxaccl);
            m_data.naccelmax = Integer.parseInt(txt.getText().toString());

            if(commtasks.sendSetting1(m_data) < 0) {
                MainActivity.ShowMessage("データの保存に失敗しました");
                return;
            }
            finish();


        } catch (NumberFormatException ex) {
            MainActivity.ShowMessage(getString(R.string.ids_em_invfmt));
        }
        catch (Exception e) {
            MainActivity.ShowMessage(getString(R.string.ids_em_invval));
        }
    }

    public boolean handleMessage(Message msg) {
        if(msg.what == commtasks.MESSAGE_COMM_ERROR) {
            Toast.makeText(this, getString(R.string.ids_em_comerr), Toast.LENGTH_SHORT).show();
        }
        else if(msg.what == commtasks.MESSAGE_ACCELVAL_REQUEST) {
            TextView txt = (TextView)findViewById(msg.arg2);
            txt.setText(String.valueOf(msg.arg1));

        }
        return true;
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.btns1save:
                OnSave();
                break;
            case R.id.btns1getmin:
                commtasks.m_Instance.getAccelVal(new Handler(this) , R.id.txts1minaccl);
                break;
            case R.id.btns1getmax:
                commtasks.m_Instance.getAccelVal(new Handler(this) , R.id.txts1maxaccl);
                break;
        }
    }
}
