package com.blue.penecu;

import android.content.Context;
import android.os.Handler;
import android.widget.TabHost;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InterruptedIOException;
import java.lang.reflect.Array;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.StringTokenizer;

//-------------------------------------------------------------------------------
// * Created by tagami.tomohisa on 2016/03/02.
// * このクラスはMainActivityから呼び出され、通信関連の処理を行うラッパーとなる
//-------------------------------------------------------------------------------
public  class commtasks {
    //--------------------------------- 変数
    public static final byte CMD_U = 0x55;
    public static final byte CMD_u = 0x75;
    public static final byte CMD_T = 0x54;
    public static final byte CMD_t = 0x74;
    public static final byte CMD_A = 0x41;
    public static final byte CMD_I = 0x49;
    public static final byte CMD_C = 0x43;
    public static final byte CMD_D = 0x44;
    public static final byte CMD_M = 0x4D;
    public static final byte CMD_S = 0x53;
    public static final byte CMD_a = 0x61;
    public static final byte CMD_b = 0x62;
    public static final byte CMD_c = 0x63;
    public static final byte CMD_d = 0x64;
    public static final byte CMD_f = 0x66;
    public static final byte CMD_m = 0x6D;
    public static final byte CMD_EOT =    0x04;
    public static final byte CMD_STX  =   0x02;
    public static final byte CMD_ETX  =   0x03;
    public static final byte CMD_ENQ  =   0x05;
    public static final byte CMD_ACK  =   0x06;
    public static final byte CMD_BEL  =   0x07;
    public static final byte CMD_DLE  =   0x10;
    public static final byte CMD_DC1  =   0x11;
    public static final byte CMD_NAK  =   0x15;
    public static final byte CMD_CAN  =   0x18;
    public static final byte CMD_ESC  =   0x1b;
    public static final byte CMD_DEL  =   0x7f;
    public static final int  MESSAGE_UPDATEGOES = 101;
    public static final int  MESSAGE_UPDATEREJECTED = 109;
    public static final int  MESSAGE_UPDATEFINISH = 102;
    public static final int  MESSAGE_UPDATEFINISHERROR = 104;
    public static final int  MESSAGE_UPDATEDATAERROR = 103;
    public static final int  MESSAGE_ADRESULT = 111;
    public static final int  MESSAGE_DOWN_REJECT = 121;
    public static final int  MESSAGE_DOWN_ERROR = 122;
    public static final int  MESSAGE_DOWN_FINISH = 123;
    public static final int  MESSAGE_COMM_ERROR = 199;
    public static final int  MESSAGE_FILE_ERROR = 131;
    public static final int  MESSAGE_TABLE_DATA = 140;
    public static final int  MESSAGE_TABLE_CELLU = 142;
    public static final int  MESSAGE_TABLE_SAVE_ERR = 143;
    public static final int  MESSAGE_TABLE_SAVE_FIN = 144;
    public static final int  MESSAGE_INFO_REQUEST = 151;
    public static final int  MESSAGE_ACCELVAL_REQUEST = 152;

    static Context m_context;
    private static BluetoothClientC BTclient = null;
    private static volatile boolean m_bavail;
    private static volatile Handler m_handler = null;
    private static byte[] m_wkbuff = new byte[65525];
//--------------------------------- データクラス
    public static class Setting1Data
    {
        public int verifysign1;                    // 未初期化かどうか判定用に使用、0xffffffff なら未初期化
        public int ncurrent;                       // 現在のテーブル番号、デフォルトは0とする(0 or 1)
        public int naccelmin;                      // アクセルセンサーの電圧最小値
        public int naccelmax;                      // アクセルセンサーの電圧最大値
        public int verifysign2;                    // 未初期化かどうか判定用に使用、0xffffffff なら未初期化
        public int defBTDCFireVal;                 // デフォルトの進角度、0.1度単位。デフォルトは 200にするかも
        public int defInjSpan;                     // デフォルトの噴射時間、1/100ミリ秒単位 デフォルトは 400
        public int defIgnSpan;                     // デフォルトのIGN通電時間、1/100ミリ秒単位 デフォルトは 640
        public int IsUseAccelPump;                 // 加速ポンプ機能、デフォルトオフ
        public int nAccelPumpSpan;                 // 加速ポンプ効果時間、0.1秒単位, デフォルト30
        public int IsTunnelMode;                   // トンネルモード。信号をそのまま再現して、ノーマルと同じにする

        public void Normarize() {
            ncurrent = _ChgOrder(ncurrent);
            naccelmin = _ChgOrder(naccelmin);
            naccelmax = _ChgOrder(naccelmax);
            defBTDCFireVal = _ChgOrder(defBTDCFireVal);
            defInjSpan = _ChgOrder(defInjSpan);
            defIgnSpan = _ChgOrder(defIgnSpan);
            IsUseAccelPump = _ChgOrder(IsUseAccelPump);
            nAccelPumpSpan = _ChgOrder(nAccelPumpSpan);
            IsTunnelMode = _ChgOrder(IsTunnelMode);
        }


    }
//--------------------------------　プロパティ関連
    public commtasks(Context parent)  { m_context = parent; }
    public static void SetContext(Context parent) { m_context = parent; }
    public static  boolean IsAvaialble()    { return m_bavail; }
    public static  void setM_handler(Handler handler)   {   m_handler = handler; }
    public static Handler getM_handler() { return m_handler; }
    public static commtasks m_Instance;
    //--------------------------------   メソッド
    public static int _ChgOrder(int val) {
        return (((val << 24) & 0xff000000 )| ((val << 8) & 0xff0000 )|((val >> 8) & 0xff00 )|((val >> 24) & 0xff ));
    }

    public static void setBTclient(BluetoothClientC bc) {
        BTclient = bc;
    }

    public  boolean AliveChk1() {
        if(BTclient == null)
            return false;

        if (BTclient.write(CMD_DC1) < 0)
            return false;
        try { Thread.sleep(100);}
        catch(Exception e) {

        }

        int nread = BTclient.read(m_wkbuff);
        return nread > 0;
    }

    public static boolean AliveChk() {
        if(BTclient == null)
            return false;

        int nAckChkCnt = 3;
        while(nAckChkCnt > 0)  {
            if (BTclient.write(CMD_DC1) < 0)
                return false;
            int nread = BTclient.read(m_wkbuff);
            if(nread > 0)
                if(m_wkbuff[0] == CMD_ACK)
                    nAckChkCnt--;
        }
        return true;
    }

    //--------------------------------   ターミナル関連ジョブ
    public int TerminalJob(String strSend, Handler handler)    {
        CommThread connecting = new CommThread(this, BTclient, strSend, handler );		// 接続スレッドを生成
        connecting.start();							// スレッド開始
        return 0;
    }
    //--------------------------------   プログラム更新処理
    public int updatePGM(String srcSrcFileName, Handler handler){
        FileInputStream  fis = null;
        try {
            File    file = new File(srcSrcFileName);
            if(!file.canRead())
                return -2;
            int nbyte =(int) file.length();
            if(nbyte == 0)
                return -2;
            fis = new FileInputStream(file);
            byte[] bdata = new byte[nbyte];
            fis.read(bdata, 0, nbyte);
            fis.close();
            fis = null;
            CommThread connecting = new CommThread(this, BTclient, CMD_u, bdata, handler != null ? handler : m_handler  );		// 接続スレッドを生成
            connecting.start();							// スレッド開始
        }
        catch(FileNotFoundException e)  {
            return -1;
        }
        catch (IOException e) {
            return -2;
        }
        finally {
            try {
                if (fis != null)
                    fis.close();
            }
            catch (IOException e) {
            }
        }
        return 0;
    }

    //--------------------------------   ファイル送信処理１
    public int sendFile(String strDst, String srcSrcFileName, Handler handler){
        FileInputStream  fis = null;
        try {
            File    file = new File(srcSrcFileName);
            if(!file.canRead())
                return -2;
            int nbyte =(int) file.length();
            if(nbyte == 0)
                return -2;
            fis = new FileInputStream(file);
            byte[] bdata = new byte[nbyte];
            fis.read(bdata, 0, nbyte);
            fis.close();
            fis = null;
            byte[] hexdata = BIN2HEX(bdata);
            bdata = null;
            CommThread connecting = new CommThread(this, BTclient, handler, CMD_U, strDst, hexdata  );		// 接続スレッドを生成
            connecting.start();							// スレッド開始
        }
        catch(FileNotFoundException e)  {
            return -1;
        }
        catch (IOException e) {
            return -2;
        }
         finally {
            try {
                if (fis != null)
                    fis.close();
            }
            catch (IOException e) {
            }
        }
        return 0;
    }

    //--------------------------------   ファイル送信処理１
    public int recvFile(String strDst, String srcSrcFileName, Handler handler){
        FileOutputStream  fis = null;
        try {
            fis = new FileOutputStream(srcSrcFileName);
            //fis = m_context.openFileOutput(strDst, Context.MODE_WORLD_WRITEABLE);

            CommThread connecting = new CommThread(this, BTclient, handler, CMD_D, strDst, fis  );		// 接続スレッドを生成
            connecting.start();							// スレッド開始
            return 0;
        }
        catch(FileNotFoundException e)  {
            handler.obtainMessage(MESSAGE_COMM_ERROR, e.getMessage()).sendToTarget();
            return -1;
        }
    }

    //
    public static void test() {

    }

    //---------------------------- 設定データ受信
    public static int recvSetting1(Setting1Data data) {
        try {
            int  nread;
            if(!AliveChk())
                return -1;
            if(BTclient.write(CMD_d) < 0) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -2;
            }

            if ((nread = BTclient.read(m_wkbuff, 1)) < 0 || m_wkbuff[0] != CMD_ACK) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -3;
            }

            boolean isEof = false;
            ByteArrayOutputStream bs = new ByteArrayOutputStream();
            while (!isEof) {
                int nttl = 0;
                do {
                    if ((nread = BTclient.read(m_wkbuff, 128)) < 0) {
                        m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                        return -4;
                    }
                    if (m_wkbuff[nread - 1] == CMD_EOT) {
                        if (nread - 1 > 0)
                            bs.write(m_wkbuff, 0, nread - 1);
                        isEof = true;
                        break;
                    } else {
                        bs.write(m_wkbuff, 0, nread);
                    }

                    nttl += nread;
                }
                while(nttl < 128);
            }
            byte[] bindata = HEX2BIN(bs.toByteArray());
            bs.close();
            bs = null;
            ByteBuffer iArray = ByteBuffer.wrap(bindata).order(ByteOrder.LITTLE_ENDIAN);
            data.verifysign1 = iArray.getInt(0);
            data.ncurrent = iArray.getInt(4);
            data.naccelmin = iArray.getInt(8);
            data.naccelmax = iArray.getInt(12);
            data.verifysign2 = iArray.getInt(16);
            data.defBTDCFireVal = iArray.getInt(20);
            data.defInjSpan = iArray.getInt(24);
            data.defIgnSpan = iArray.getInt(7*4);
            data.IsUseAccelPump = iArray.getInt(8*4);
            data.nAccelPumpSpan = iArray.getInt(9*4);
            data.IsTunnelMode = iArray.getInt(10*4);

        }
        catch (Exception eb) {

        }
        return 0;
    }

    //---------------------------- 設定データ送信
    public static int sendSetting1(Setting1Data data) {
        try {
            byte []  binBuff = new byte[44];
            byte[]  senddata;
            ByteBuffer bbin = ByteBuffer.wrap(binBuff).order(ByteOrder.LITTLE_ENDIAN);
            bbin.putInt(0, 0);
            bbin.putInt(4, data.ncurrent);
            bbin.putInt(2*4, data.naccelmin);
            bbin.putInt(3*4, data.naccelmax);
            bbin.putInt(4*4, 0);
            bbin.putInt(5 * 4, data.defBTDCFireVal);
            bbin.putInt(6*4, data.defInjSpan);
            bbin.putInt(7*4, data.defIgnSpan);
            bbin.putInt(8*4, data.IsUseAccelPump);
            bbin.putInt(9*4, data.nAccelPumpSpan);
            bbin.putInt(10*4, data.IsTunnelMode);
            senddata = BIN2HEX(binBuff);

            int  nread;
            if(!AliveChk())
                return -1;
            if(BTclient.write(CMD_c) < 0) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -2;
            }

            if ((nread = BTclient.read(m_wkbuff, 1)) < 0 || m_wkbuff[0] != CMD_ACK) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -3;
            }

            if(BTclient.write(senddata) < 0){
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -4;
            }
            if(BTclient.write(CMD_EOT) < 0) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -4;
            }
            if ((nread = BTclient.read(m_wkbuff, 1)) < 0 || m_wkbuff[0] != CMD_ACK) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -5;
            }


        }
        catch (Exception eb) {
            return -6;

        }
        return 0;
    }

    //---------------------------- 設定データ受信
    public static int recvInfo(MainActivity.InfoData  info) {
        try {
            int  nread;
            byte buff[] = new byte[10];
            byte mkshort[] = new byte[20];

            if(BTclient.write(CMD_I) < 0) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR, 0, 0).sendToTarget();
                return -2;
            }

            for(int i = 0; i < 10; ) {
                if ((nread = BTclient.read(buff, 10)) < 0) {
                    m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                    return -4;
                }
                for(int j = 0; j < nread; j++)
                    m_wkbuff[i + j] = buff[j];
                i += nread;
            }
            for(int i = 0, j = 0; j < 10; j++) {
                mkshort[i++] = 0;
                mkshort[i++] = m_wkbuff[j];
            }
            ByteBuffer bb = ByteBuffer.wrap(mkshort);

            info.m_volt = bb.getShort(0);
            info.m_rpm = bb.getShort(2);
            info.m_accel = bb.getShort(4);
            info.m_temp1 = m_wkbuff[3];
            info.m_temp2 = m_wkbuff[4];
            info.m_o2 = bb.getShort(10);
            info.m_injtime = bb.getShort(12);
            info.m_btdcangle = bb.getShort(14);
            info.m_errcode = bb.getShort(18);

        }
        catch (Exception eb) {
            return  -1;
        }
        return 0;
    }

    //---------------------------- テーブル指定でバイナリデータ取得
    public int getTableData(int tblno, Handler hret) {
        CommThread connecting = new CommThread(this, BTclient, hret, CMD_t, new Integer(tblno), null  );		// 接続スレッドを生成
        connecting.start();							// スレッド開始
        return 0;
    }

    //---------------------------- テーブル指定でバイナリデータ取得
    public int setTableCellData(int tblno, int col, int row, short data, Notice hret) {
        if(BTclient == null)    return -1;
        int     tblcolrow = (tblno << 16) + (col << 8) + row;
        CommThread connecting = new CommThread(this, BTclient, null, CMD_M, new Integer(tblcolrow), new Integer(data)  );		// 接続スレッドを生成
        connecting.m_notice = hret;
        connecting.start();							// スレッド開始
        return 0;

    }
    //---------------------------- テーブル指定でバイナリデータ取得
    public int saveTables(int membank, Handler hret) {
        CommThread connecting = new CommThread(this, BTclient, hret, CMD_S, new Integer(membank), null  );		// 接続スレッドを生成
        connecting.start();							// スレッド開始
        return 0;

    }

    public void getADResult(Handler hret) {
        CommThread connecting = new CommThread(this, BTclient, hret, CMD_A, null, null  );		// 接続スレッドを生成
        connecting.start();							// スレッド開始
    }

    public  void getAccelVal(Handler hret, int param) {
        CommThread connecting = new CommThread(this, BTclient, hret, CMD_f, param, null  );		// 接続スレッドを生成
        connecting.start();							// スレッド開始
    }

    //------------------------------ Handlerの代わりに処理が終わったことを知るために単純なオブジェクト
    public class Notice {
        public boolean isFinished = false;
        public boolean isError = false;
        public Notice() {}
        public void setisFinished() {
            synchronized (this)  {
                isFinished = true;
            }
        }
        public boolean getIsFinished() {
            synchronized (this) {
                return isFinished;
            }
        }
    }
     //--------------------------------------------------------------------------------
    //  スレッドによる通信処理実行クラス
    //--------------------------------------------------------------------------------
    private class CommThread extends Thread {
        // Socket初期化処理
        commtasks   m_parent;
        BluetoothClientC m_bc;
        Object  m_param1, m_param2;
        byte    m_cCmd;
        volatile boolean  m_IsCmdMode;
        volatile Handler m_handler = null;
        byte[]  m_data = null;
        byte[] m_dtwk = new byte[4096];
        Notice m_notice;
    //
        public CommThread(commtasks parent, BluetoothClientC bc, Handler handler,  byte cCmd, Object param1, Object param2 ) {
            m_parent = parent;
            m_bc = bc;
            m_cCmd = cCmd;
            m_param1 = param1;
            m_param2 = param2;
            m_IsCmdMode = true;
            m_handler = handler;
        }

        public CommThread(commtasks parent, BluetoothClientC bc, String sSend, Handler hafter ) {
            m_parent = parent;
            m_bc = bc;
            m_IsCmdMode = false;
            m_param1 = sSend;
            m_param2 = hafter;
        }

        public CommThread(commtasks parent, BluetoothClientC bc, byte cCmd, byte[] data, Handler hafter ) {
            m_parent = parent;
            m_bc = bc;
            m_cCmd = cCmd;
            m_IsCmdMode = true;
            m_data = data;
            m_handler = hafter;
        }

        public void run() {
                CommMain();
        }

        void Sleep(int ms) {
            try {
                Thread.sleep((long)ms);
            }
            catch (InterruptedException e) {

            }
        }

        //--------------------------------   生存確認電文を複数回投げて、生存を確認する
        protected boolean AliveChk() {
            int nAckChkCnt = 3;
            if(m_bc == null)    return false;
            while(nAckChkCnt > 0)  {
                if (m_bc.write(CMD_DC1) < 0)
                    return false;
                int nread = m_bc.read(m_dtwk);
                if(nread > 0)
                    if(m_dtwk[0] == CMD_ACK)
                        nAckChkCnt--;
            }
            return true;
        }
        //--------------------------------   プログラム更新通信処理本体
        private void cmd_u() {

            byte[] bsend = new byte[80];
            byte[] sdatas = m_data;
            byte[] rbuff1 = new byte[80];
            int nlen = sdatas.length, nread = 0, nsend    ;

            AliveChk();

            if(m_bc.write(CMD_u) < 0) {
                m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, 0, 0).sendToTarget();
                return;
            }

            if ((nread = m_bc.read(rbuff1, 1)) < 0) {
                m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, 0, 0).sendToTarget();
                return;
            }

            if (rbuff1[0] == CMD_NAK)    {    // 現在不可
                m_handler.obtainMessage(MESSAGE_UPDATEREJECTED).sendToTarget();
                return;
            }

            if (rbuff1[0] != CMD_ACK && rbuff1[0] != 0x34  ) {
                m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, 0, 0).sendToTarget();
                return;
            }
            if (rbuff1[0] == CMD_ACK) {
                Sleep(150);     // リブート待ち
                AliveChk();
                if(m_bc.write(CMD_u) < 0) {
                    m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, 0, 0).sendToTarget();
                    return;
                }
                do {
                    if ((nread = m_bc.read(rbuff1, 1)) < 0) {
                        m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, 0, 0).sendToTarget();
                        return;
                    }
                }while(rbuff1[0] != 0x34);
            }

            if( rbuff1[0] != 0x34) {
                m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, 0, 0).sendToTarget();
                return;
            }
            Sleep(50);

            for(int i = 0, nLine = 0; i < nlen; i++) {
                if(m_bc.write((byte)0x35) < 0) {
                    m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, ++nLine, 0).sendToTarget();
                    return;
                }
                nread = m_bc.read(rbuff1);
                if(rbuff1[0] != 0x35){
                    m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, ++nLine, 0).sendToTarget();
                    return;
                }


                for(nsend = 0; sdatas[i] != 0x0a;)   {
                    bsend[nsend++] = sdatas[i++];
                }
                if(i + 1 >= nlen)       // 最後の1文字
                    bsend[nsend++] = 0x00;
                else
                    bsend[nsend++] = 0x0a;
                m_bc.write(bsend, nsend);
                if((++nLine % 10) == 0)
                    m_handler.obtainMessage(MESSAGE_UPDATEGOES, nLine, 0).sendToTarget();

                if(m_bc.read(rbuff1) < 0) {
                    m_handler.obtainMessage(MESSAGE_UPDATEDATAERROR, ++nLine, 0).sendToTarget();
                    return;
                }
                if(rbuff1[0] == 0x39)       // 最後、9が返る
                    break;
            }
            m_handler.obtainMessage(rbuff1[0] == 0x39 ? MESSAGE_UPDATEFINISH: MESSAGE_UPDATEFINISHERROR).sendToTarget();
            Sleep(550);     // リブート待ち
            AliveChk();
        }

        //--------------------------------   ファイルデータをテーブルに書き込み通信本体
        private void cmd_U() {
            String sfname = (String) m_param1;
            byte[] bdata = (byte[]) m_param2;
            m_bc.write(CMD_U);
            m_bc.write(CMD_STX);
            m_bc.write(sfname.getBytes());
            m_bc.write(CMD_ETX);
            m_bc.write(bdata);
            m_bc.write(CMD_EOT);
            bdata = null;
            m_param2 = null;
        }
        //--------------------------------   ファイルデータをテーブルに書き込み通信本体
        private void cmd_D() {
            int     n1Line = 256;
            String  sparam;
            byte[]  rbuff = new byte[512];
            String sfname = (String) m_param1;
            ByteArrayOutputStream bs = new ByteArrayOutputStream();
            FileOutputStream fos = (FileOutputStream) m_param2;
            try {
                if(!AliveChk()) {
                    m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                    return;
                }

                m_bc.write(CMD_D);
                if (sfname == "mapfile1")
                    sparam = "02";
                else if (sfname == "mapfile2")
                    sparam = "03";
                else if (sfname == "log1")
                    sparam = "21";
                else if (sfname == "log2")
                    sparam = "22";
                else //if (sfname == "diaginfo")
                    sparam = "90";
                m_bc.write(sparam.getBytes());
                m_bc.write(CMD_ETX);
                if (m_bc.read(rbuff, 1) < 0) {
                    m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                    return;
                }
                if (rbuff[0] != CMD_ACK) {
                    m_handler.obtainMessage(MESSAGE_DOWN_ERROR).sendToTarget();
                    return;
                }
                boolean isEof = false;
                while (!isEof) {
                    int nread, nttl = 0;
                    do {
                        if ((nread = m_bc.read(rbuff, n1Line)) < 0) {
                            m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                            return;
                        }
                        if (rbuff[nread - 1] == CMD_EOT) {
                            if (nread - 1 > 0)
                                bs.write(rbuff, 0, nread - 1);
                            isEof = true;
                            break;
                        } else {
                            bs.write(rbuff, 0, nread);
                        }

                        nttl += nread;
                    }
                    while(nttl < n1Line);
                	if(!isEof)
                    	m_bc.write(CMD_ACK);
                }
                byte[] bindata = HEX2BIN(bs.toByteArray());
                fos.write(bindata);
                m_handler.obtainMessage(MESSAGE_DOWN_FINISH).sendToTarget();

            }
            catch (Exception e) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
            }
            finally {
                try {    if(fos != null)   fos.close(); }catch (IOException e) {}
            }
        }

        //--------------------------------   minスロットル設定通信本体
        private void cmd_a() {

        }
        //--------------------------------   maxスロットル設定通信本体
        private void cmd_b() {

        }
        //--------------------------------
        private void cmd_d() {

        }
        //--------------------------------
        private void cmd_c() {

        }
        //--------------------------------   スロットル設定通信本体
        private void cmd_f() {
            if(!AliveChk()) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }
            m_dtwk[0] = CMD_f;
            if(m_bc.write(m_dtwk, 1) < 0) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }
            if (m_bc.read(m_dtwk, 2) < 0){
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }

            int  ival = ((m_dtwk[0] << 8) & 0xff00) | (m_dtwk[0] & 0xff);

            m_handler.obtainMessage(MESSAGE_ACCELVAL_REQUEST, ival, ((Integer)m_param1).intValue()).sendToTarget();

        }
        //--------------------------------   テーブルデータ設定通信本体
        private void cmd_M() {
            int  param1 = ((Integer)m_param1).intValue();
            int  param2 = ((Integer)m_param2).intValue();
            m_dtwk[0] = CMD_M;
            m_dtwk[1] = (byte)((param1 >> 16) & 0xff);  // TBLNO
            m_dtwk[2] = (byte)((param1 >> 8) & 0xff);   // COL
            m_dtwk[3] = (byte)(param1 & 0xff);          // ROW
            m_dtwk[4] = (byte)((param2 >> 8) & 0xff);   // ValHi
            m_dtwk[5] = (byte)(param2 & 0xff);          // ValLo

            m_bc.write(m_dtwk, 6);
            if (m_bc.read(m_dtwk, 1) < 0 || m_dtwk[0] != CMD_ACK) {
                if(m_notice != null) {
                    m_notice.isError = true;
                    m_notice.setisFinished();
                }
                return;
            }
            //if(m_handler != null) {
            //    m_handler.obtainMessage(MESSAGE_TABLE_CELLU).sendToTarget();
            //}
            if(m_notice != null)
                m_notice.setisFinished();
        }
        //--------------------------------   セッティングデータ保存通信本体
        private void cmd_S() {
            if(!AliveChk()) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }
            int  param1 = ((Integer)m_param1).intValue();
            m_dtwk[0] = CMD_S;
            m_dtwk[1] = (byte)(param1 & 0xff);  // 1 or 2, 保存FlushMemoryバンク
            if(m_bc.write(m_dtwk, 2) < 0) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }
            if (m_bc.read(m_dtwk, 1) < 0){
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }
            if(m_dtwk[0] == CMD_ACK) {
                m_handler.obtainMessage(m_dtwk[0] == CMD_ACK ? MESSAGE_TABLE_SAVE_FIN : MESSAGE_TABLE_SAVE_ERR).sendToTarget();
                return;
            }
        }
        //--------------------------------   現在の設定選択通信本体
        private void cmd_C() {

        }

        private void cmd_T() {

        }
        private void cmd_t() {
            if(!AliveChk()) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }
            byte[]  rbuff = new byte[10000];
            byte[]  lenbuff = new byte[32];
            byte  tblno = ((Integer)m_param1).byteValue();
            int     n1Line = 256;
            int     len, nread;
            ByteArrayOutputStream bs = new ByteArrayOutputStream();
            rbuff[0] = CMD_t;
            rbuff[1] = tblno;
            m_bc.write(rbuff, 2);
            if (m_bc.read(rbuff, 1) < 0 || rbuff[0] != CMD_ACK) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }
//            len = 4;
//            while(len > 0) {
//                if ((nread = m_bc.read(lenbuff, 4 - len, len)) < 0) {
//                    m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
//                    return;
//                }
//                len -= nread;
//            }
//            len = ByteBuffer.wrap(lenbuff).order(ByteOrder.LITTLE_ENDIAN).getInt(0);
//            while(len > 0) {
//                if ((nread = m_bc.read(rbuff, len)) < 0) {
//                    m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
//                    return;
//                }
//                bs.write(rbuff, 0, nread);
//                len -= nread;
//            }
            boolean isEof = false;
            while (!isEof) {
                int nttl = 0;
                do {
                    if ((nread = m_bc.read(rbuff, n1Line)) < 0) {
                        m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                        return;
                    }
                    if (rbuff[nread - 1] == CMD_EOT) {
                        if (nread - 1 > 0)
                            bs.write(rbuff, 0, nread - 1);
                        isEof = true;
                        break;
                    } else {
                        bs.write(rbuff, 0, nread);
                    }

                    nttl += nread;
                }
                while(nttl < n1Line);
//                if(!isEof)
//                    m_bc.write(CMD_ACK);
            }
            byte[] bindata = HEX2BIN(bs.toByteArray());
            m_handler.obtainMessage(MESSAGE_TABLE_DATA, tblno, 0, bindata ).sendToTarget();
        }

        private void cmd_A() {
            ByteArrayOutputStream bs = new ByteArrayOutputStream();
            byte[] buff = new byte[4096];
            m_bc.write(CMD_A);
            if (m_bc.read(buff, 1) < 0 || buff[0] != CMD_ACK) {
                m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                return;
            }

            int  len = 4000, nread = 0;
            while(len > 0) {
                int  len1data = len <  256 ? len : 256;
                while(len1data > 0) {
                    nread = m_bc.read(buff, len1data);
                    if (nread < 0) {
                         m_handler.obtainMessage(MESSAGE_COMM_ERROR).sendToTarget();
                         return;
                    }
                    bs.write(buff, 0, nread);
                    len -= nread;
                    len1data -= nread;
                }
                 m_bc.write(CMD_ACK);
            }
//             byte[] ret = HEX2BIN(bs.toByteArray());
            byte[] ret = bs.toByteArray();
//                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              byte[] ret = bs.toByteArray();
             bs = null;
             m_handler.obtainMessage(MESSAGE_ADRESULT, ret).sendToTarget();
         }

        //--------------------------------   スレッドから呼ばれる排他アクセス付通信本体メソッド
        public synchronized void CommMain() {
            m_bavail = false;
            if(m_IsCmdMode) {
                switch (m_cCmd) {
                    case CMD_I:
                        break;
                    case CMD_M:
                        cmd_M();
                        break;
                    case CMD_A:
                        cmd_A();
                        break;
                    case CMD_U:
                        cmd_U();
                        break;
                    case CMD_u:
                        cmd_u();
                        break;
                    case CMD_a:
                        cmd_a();
                        break;
                    case CMD_b:
                        cmd_b();
                        break;
                    case CMD_c:
                        cmd_c();
                        break;
                    case CMD_d:
                        cmd_d();
                        break;
                    case CMD_C:
                        cmd_C();
                        break;
                    case CMD_D:
                        cmd_D();
                        break;
                    case CMD_S:
                        cmd_S();
                        break;
                    case CMD_T:
                        cmd_T();
                        break;
                    case CMD_t:
                        cmd_t();
                        break;
                    case CMD_f:
                        cmd_f();
                        break;
                    default:
                        break;
                }
            }
            else {
                byte[] ret = new byte[1024*1024];
                String sSend = (String)m_param1;
                m_bc.write(sSend.getBytes());
                int nread = m_bc.read(ret);
                String sRet = new String(ret, 0, nread);
                Handler handler = (Handler)m_param2;
                handler.obtainMessage(1, 0, 0, sRet).sendToTarget();

            }
            m_bavail = true;
        }
    }
            // 16進文字列変換
    public static byte[] BIN2HEX(byte[] thedata){
        byte[] ret = new byte[thedata.length * 2];
        for(int i = 0; i < thedata.length; i++){
            byte hb =(byte)( ((thedata[i] >> 4) & 0x0f) + 0x30);
            byte lb = (byte)((thedata[i]  & 0x0f) + 0x30);
            if(hb > 0x39)  hb += 7;
            if(lb > 0x39)  lb += 7;
            ret[i << 1] = hb;
            ret[(i << 1) + 1] = lb;
        }
        return ret;
    }

    public static byte[] HEX2BIN(byte[] thedata){
        byte[] ret = new byte[thedata.length >> 1];
        for(int i = 0; i < thedata.length; i += 2){
            int hb = thedata[i];
            int lb = thedata[i + 1];
            if (hb > 0x60)  hb -= 0x57;
            else if(hb > 0x40)  hb -= 0x37;
            else    hb -= 0x30;
            if (lb > 0x60) lb -= 0x57;
            else if(lb > 0x40)  lb -= 0x37;
            else    lb -= 0x30;
            ret[i >> 1] = (byte)((hb << 4) | lb);
        }
        return ret;
    }

}
